Bug 20733 - Format need to define how to negotiate: width, height, frame-rate
Summary: Format need to define how to negotiate: width, height, frame-rate
Status: RESOLVED FIXED
Alias: None
Product: WebRTC Working Group
Classification: Unclassified
Component: Media Capture and Streams (show other bugs)
Version: unspecified
Hardware: All All
: P2 major
Target Milestone: ---
Assignee: savannah55
QA Contact:
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2013-01-22 12:53 UTC by j.chetwynd
Modified: 2013-07-16 13:53 UTC (History)
2 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description j.chetwynd 2013-01-22 12:53:29 UTC
Suggestion: browser should honour user defined format and frame rate.
possibly subject to camera providing given format and frame rate, 

afaict 

There is currently no defined way to negotiate the video format

  A camera may offer a variety of formats and frame rates

  The user may have chosen a desired format and frame rate

  The browser may auto-select a format and frame rate

Evidence:

  Method:
    set format and frame rate:**
      $ v4l2-ctl --set-fmt-video=width=320,height=240  //320x240
      $ v4l2-ctl --set-parm=60  //60fps
      $ v4l2-ctl --all  // check current settings

    load http://www.gnote.org in browser

    check format and frame rate again:
      $ v4l2-ctl --all  // ie did they change?
      
  Results:

    Chrome v24.0.1312.52 
      format is changed to 640x480
      user defined fps is retained

    Opera v12.12.1707
      user defined format is retained
      fps is changed to 25fps

    Firefox 21.0a1 (2013-01-21)
      format is changed to 640x480
      fps is changed to 30fps

Tests were not exhaustive, it may be helpful to have other tests, particularly using a UVC compliant camera

my apologies if I missed something obvious.

~:"

**  v4l2 is a Linux API to control camera output
    v4l2-ctl provides an interface to this API

    Camera: Sony Eye Camera available formats:
      640x480@15
      640x480@30
      640x480@40
      640x480@50
      640x480@60
      320x240@30
      320x240@40
      320x240@50
      320x240@60
      320x240@75
      320x240@100
      320x240@125
Comment 2 Harald Alvestrand 2013-03-25 11:04:25 UTC
Discussion of this topic was present in the "version 6" constraints proposal, and should probably be added as an informative section of the spec. Assigning to Dan for now.
Comment 3 Harald Alvestrand 2013-06-12 08:44:39 UTC
Discussion of resolution is added in the May 29 version of the spec:

http://dev.w3.org/2011/webrtc/editor/getusermedia.html#the-model-sources-sinks-constraints-and-states

It is clear that the browser CAN change the format and frame rate.
Comment 4 Harald Alvestrand 2013-07-16 13:53:01 UTC
Closing as fixed.